 
/*These imports are for the VRML nodes, etc etc. */ 
import vrml.external.Node;  
import vrml.external.Browser;  
import vrml.external.field.*; 
import vrml.external.exception.*; 
 
/* Java Specific classes */ 
import java.util.*;  
import java.net.*;  
import java.io.*; 
import java.awt.*; 
import java.applet.Applet; 
 
/* Netscape's javascript classes to get browser handle */ 
import netscape.javascript.*; 
 
import org.omg.CORBA.*; 
 
/*The IIOP-Collab specific part */ 
import Client.*; 
import MultiCoordinator.*; 
import PartyScheduler.*; 
 
/*This is a porting of the initial prototype of a collaboratory VRML, world 
  by Balaji Natarajan & Shrideep Pallickara 
   @version     Alpha 1.0 22nd October 1997 
   @author      Shrideep Pallickara / Balaji Natrajan 
   @author      NorthEast Parallel Architectures Center 
 */ 
 
public class 
CVRUser extends Applet implements MuProtocol, Runnable,EventOutObserver { 
  /*The MultiCoordinator contains handles to all the Clients within a certain  
    Party */ 
  public MultiCoordinator.Coordinator myCoordinator; 
 
  /*The Party Scheduler is the dude which maintains all the Party Handles */ 
  public PartyScheduler.PartyCoordinator partyCoordinator; 
 
  /** Info pertinent to the Client. */ 
  public String clientName; 
  public int clientID; 
 
  /**Info pertinent to the Party*/ 
  public String partyName="Wojtek"; 
 
  /*The party Handle is always received against the partyID */ 
  public int partyID; 
   
  /** Indicates if the client is successfully connected to the server. */ 
  boolean connected = false; 
   
  private Thread running = null; 
  private Thread controlThread; 
  public  String clientNumber="1"; 

  int flag =1;
  float rotval = 0.0f; 
 
   
  /*Information pertinent to modifying the VRML world */ 
  public final static int AVATARS = 3;  
  private Browser b = null;                      
  EventInSFVec3f avatarPosition[] = new EventInSFVec3f[AVATARS];           
  EventInSFRotation avatarRotation[] = new EventInSFRotation[AVATARS];  
  float[] coord = new float[3];  
  float[] rotation;  
  public int id;  
   
  String connect_info = 0+ " " + 0 +" " + 0; 
  int [] information = {0,0,0}; 
 
  private Node TS2 = null; 
  private Node PS2 = null; 
  private Node avatar = null;  
   
  private EventOutSFBool clicked1 = null; 
  private EventOutSFVec3f currentPosition = null; 
  Button tester; 
  Button mover; 
  Button navigatex; 
  Button _navigatex; 
  Button navigatey; 
  Button _navigatey; 
  Button navigatez; 
  Button _navigatez; 
 
  float x_trial=3.0f; 
 
  float x_trial0=0.0f, x_trial1=0.0f, x_trial2=0.0f; 
  float y_trial0=0.0f, y_trial1=0.0f, y_trial2=0.0f; 
  float z_trial0=0.0f, z_trial1=0.0f, z_trial2=0.0f; 
 
  boolean x_increase=false; 
  boolean y_increase=false; 
  boolean z_increase=false; 
  boolean x_decrease=false; 
  boolean y_decrease=false; 
  boolean z_decrease=false; 
 
  public synchronized void init(){  
     /* to get the handle of the CosmoPlayer browser,liveconnect is used*/ 
 
    JSObject win = JSObject.getWindow(this); 
    JSObject doc = (JSObject)win.getMember("document"); 
    JSObject embeds = (JSObject)doc.getMember("embeds"); 
     
    b = (Browser)embeds.getSlot(0); 
     
    System.out.println("Handle to VRML Browser got...."); 
     
    tester=new Button("JOIN"); 
    add(tester); 
     
    mover = new Button("Move"); 
    //add(mover); 
     
    navigatex= new Button("NavigateX+"); 
    add(navigatex); 
     
    _navigatex= new Button("NavigateX-"); 
    add(_navigatex); 
     
    navigatey = new Button("NavigateY+"); 
    add(navigatey); 
     
    _navigatey = new Button("NavigateY-"); 
    add(_navigatey); 
     
    navigatez = new Button("NavigateZ+"); 
    add(navigatez); 
 
    _navigatez = new Button("NavigateZ-"); 
    add(_navigatez); 
     
    for (int i=0; i < AVATARS; i++){  
      try {  
	System.out.println("Trying to get node handle...."); 
	avatar = b.getNode("AVATAR"+i); 
	System.out.println("handle to avatar node got here..."); 
	avatarPosition[i] = (EventInSFVec3f)avatar.getEventIn("translation"); 
	avatarRotation[i] = (EventInSFRotation)avatar.getEventIn("rotation"); 
      } catch (Exception e) {  
	System.out.println("problem in getting avatar nodes..."); 
      }  
    }  
     
    try { 
      /* here is where the handle to the VRML node is got from the 
	 applet side making use of the browser object's getNode method */ 
       
      TS2 = b.getNode("TS2"); 
      System.out.println("TouchSensor node handle got..."); 
       
       
      PS2 = b.getNode("PS2"); 
      System.out.println("PlaneSensor node handle got..."); 
 
    } catch (InvalidNodeException e){ 
      System.out.println("Invalid Node handle-problems...."); 
            } 
     
    //Rerouting events from VRML to Java applet part... 
     
    clicked1 = (EventOutSFBool) TS2.getEventOut("isActive"); 
    currentPosition = (EventOutSFVec3f) PS2.getEventOut("position_changed"); 
     
    /*The following advise method will in turn call the "callback" 
      method which replaces the ProcessEvent method in JSAI 
      method of interaction */ 
     
    clicked1.advise(this,null); 
    currentPosition.advise(this,null); 
     
    //rotation = new float[4];  
  } 
   
  private boolean isConnected() { 
    System.out.println("ChatUser ===>>>Connect is " + connected); 
    return(connected); 
  } 
 
  private boolean connect() { 
    controlThread = new VRMLControlThread(this); 
    controlThread.start(); 
    return true; 
  } 
     
  private void binder() { 
    System.out.println("Initializing the ORB"); 
    /* Initialize the ORB */ 
       org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(this); 
 
    /* Calculate Start time */ 
    long startTime = System.currentTimeMillis(); 
     
    /* Bind to the PartyCoordinator Object */ 
    System.out.println("Attempting bind to the PartyCoordinator"); 
    partyCoordinator = PartyScheduler.PartyCoordinatorHelper.bind(orb); 
 
    /* Calculate stop time; print out statistics 
       This is included for diagonistic purposes */ 
    long stopTime = System.currentTimeMillis(); 
    System.out.println("Avg Ping to bind = " 
		       + ((stopTime - startTime)/1000f) + " secs"); 
    System.out.println("Party Scheduler is Ready"); 
  } 
   
  private void switchToCollaborationMode() { 
       
     /*If the party doesn't exist this control statement results in 
      a party being created else its joins a party */ 
    if (partyCoordinator.createParty(partyName)) { 
      System.out.println("New Party created"); 
       
    } 
    else  
      System.out.println("Party being joined"); 
 
    /*Get the partyID as a precursor to receiving the party Handle */ 
    partyID= partyCoordinator.getPartyID(partyName); 
    System.out.println("Party Id is: "+partyID); 
 
    /*Receive the Party Handle */ 
    myCoordinator = partyCoordinator.getPartyHandle(partyID); 
    System.out.println("Received Party Handle"); 
     
    /*Getting your TVR ID dude */ 
    // id = myCoordinator.numberOfMembers()-1; 
    //System.out.println("Your TVR ID dude ===" + id); 
     
 
    /*Publish your Object Reference to the ORB */ 
    connected= connect(); 
    System.out.println("READY TO MERINGUE"); 
  } 
   
  public boolean broadcast(String message) { 
    System.out.println("Initiating TVR broadcast"); 
    return myCoordinator.broadcast(message); 
  } 
 
  public boolean dataReceive(String commandLine) { 
    System.out.println("Got the message from the server" + commandLine); 
    StringTokenizer tok; 
    float x=0f, y=0f, z=0f, r=0f;     
     
    while (commandLine != null) { 
      tok = new StringTokenizer(commandLine, " ,\n\r\t"); 
      if (commandLine.equals("WelcomeToTVR")) { 
	System.out.println(commandLine); 
	return true; 
      } 
      if (tok.countTokens()==2) { 
	System.out.println("Using the button for Navigating"); 
	String checker = tok.nextToken(); 
	if ( (checker).equals("NavigatingX+")) x_increase=true; 
	if ( (checker).equals("NavigatingX-")) x_decrease = true; 
	if ( (checker).equals("NavigatingY+")) y_increase = true; 
	if ( (checker).equals("NavigatingY-")) y_decrease = true; 
	if ( (checker).equals("NavigatingZ+")) z_increase = true; 
	if ( (checker).equals("NavigatingZ-")) z_decrease = true; 
	updatePosition( (Integer.parseInt(tok.nextToken())), 0,0,0); 
	return true; 
      } 
       
       
      commandLine = null; 
      int idOfMove      = Integer.parseInt(tok.nextToken()); 
      int command = Integer.parseInt(tok.nextToken()); 
       
      x = Float.valueOf(tok.nextToken()).floatValue(); 
      y = Float.valueOf(tok.nextToken()).floatValue(); 
      z = Float.valueOf(tok.nextToken()).floatValue(); 
      System.out.println("x=" + x + " y=" + y + " z=" +z); 
      if(MuProtocol.MOVE == command){ 
	System.out.println("Ready to move baby ..."); 
	updatePosition(idOfMove, x, y, z); // update position  
      }else{ 
 	r = Float.valueOf(tok.nextToken()).floatValue(); 
 	updateOrientation(id, x, y, z, r); // update orientation 
      } 
    } 
    return true; 
  } 
   
   private void disconnect() { 
     System.out.println("Deregistring Client ID" +clientID + clientName); 
     myCoordinator.deregister(clientID); 
     System.out.println("Deregistring complete ... Listing follows"); 
 
     /*From this part on the processing is purely for 
       statistical purposes */ 
     int numberOfMembers= myCoordinator.numberOfMembers(); 
     String[] temp = new String[numberOfMembers]; 
     System.arraycopy(myCoordinator.getClientNames(),0,  
		      temp,0,numberOfMembers); 
     for (int i=0;i< numberOfMembers; i++) 
       System.out.println(temp[i]); 
     System.out.println("Listing complete"); 
   } 
 
 
   public void stop() { 
     if (running != null) { 
       running.stop(); 
       running = null; 
     } 
   }     
    
    
   public void run() {} 
    
   public void destroy() { 
     System.out.println("destroyed session"); 
   } 
 
   /*We could need this function for some random generations later on */ 
   private int rrange(int low, int high) { 
     return((int)(Math.random() * (high - low + 1) + low)); 
   } 
 
 
   public void callback(EventOut who,double when,java.lang.Object which) {  
             
       if((who == clicked1) && (!connected)){  
	 System.out.println("You have clicked on Connection "); 
	 clientName = "ShriBala"+ ":" + 
	   (rrange(0, 1000) * rrange(0, 1000)); 
	 binder(); 
	 switchToCollaborationMode(); 
	 System.out.println("Connection to server established");  
	 return;  
       } 
       else if(who == currentPosition){  
	  
       coord = ((EventOutSFVec3f)who).getValue(); 
	 System.out.println("x:" + coord[0] + "y:" + coord[1] +  
			    "z:" + coord[2] ); 
	 	  
	 if (connected) { 
	   try {  
	     // send my id and my current position to server  
	     //broadcast(id + " " + MuProtocol.MOVE + " " +  coord[0] +  
	     //       " " + coord[1] + " " + coord[2] );  
	     //     broadcast("heheheheheheheheheheheh hehehehehehe"); 
	   } catch (Exception e) {  
	     System.err.println("Caught exception while myPosition: " + e); 
	   }  
	 } 
       }  
        
     }  
    
   public boolean 
     action(Event event, java.lang.Object obj) { 
     System.out.println("CVRUser: action."); 
      
     if ("JOIN".equals(obj)) { 
       clientName = "ShriBala"+ ":" + 
	   (rrange(0, 1000) * rrange(0, 1000)); 
       binder(); switchToCollaborationMode(); 
       return(true); 
     } 
     if ("Move".equals(obj)) { 
       broadcast("WelcomeToTVR"); 
       return true; 
     } 
 
     if ("NavigateX+".equals(obj)) { 
       broadcast("NavigatingX+"+ " " + id); 
     } 
 
     if("NavigateX-".equals(obj)) { 
       broadcast("NavigatingX-" + " " + id); 
     } 
 
     if("NavigateY+".equals(obj)) { 
       broadcast("NavigatingY+" + " " + id); 
     } 
 
     if("NavigateY-".equals(obj)) { 
       broadcast("NavigatingY-" + " " + id); 
     } 
 
     if("NavigateZ+".equals(obj)) { 
       broadcast("NavigatingZ+" + " " + id); 
     } 
 
     if("NavigateZ-".equals(obj)) { 
       broadcast("NavigatingZ-" + " " + id); 
     } 
 
 
 
      
	return false; 
   }		       
			       
 
   public void updatePosition(int id, float x, float y, float z){   
     float trial[] = new float[3];  
     trial[1] = 0; 
     trial[2] = 0; 
 
     if (id==0) { 
       if (x_increase)  {
                  if (flag == 1) rotval = rotval;
			else if(flag == 3)rotval = rotval +3.14;
                  else if(flag ==2)rotval = rotval + 1.57f;
                  else if (flag == 4) rotval = rotval - 1.57f;
                  x_trial0 +=0.2f; 
			avatarRotation[id].setValue(x_trial0,2.0f,0.0f,rotval);		
                  flag = 1;
                 }
       else if (x_decrease) {
               if(flag == 1){
                  rotval = rotval + 3.14f;
			x_trial0 -=0.2f; 
                  avatarRotation[id].setValue(x_trial0,2.0f,0.0f,rotval);
                  }
               else if(flag ==2){
			rotval = rotval +4.71f;
			x_trial0 -=0.2f;
			avatarRotation[id].setValue(x_trial0,2.0f,0.0f,rotval);
                  }
               else if(flag == 0) {
			rotval = rotval - 1.57f;
                  x_trial0 -=0.2f;
                 	avatarRotation[id].setValue(x_trial0,2.0f,0.0f,rotval);
                  }
               else if (flag == 3) {
			x_trial0 -=0.2f;
			avatarRotation[id].setValue(x_trial0,2.0f,0.0f,rotval);
                  }
               else if (flag == 4) {
			rotval = rotval + 1.57f;
			x_trial0 -=0.2f;
		      avatarRotation[id].setValue(x_trial0,2.0f,0.0f,rotval);
                  }

                   flag = 3;
            }
                  
			
       trial[0] = x_trial0;  
 
       if (y_increase) y_trial0 +=0.2f; 
       else if (y_decrease) y_trial0 -=0.2f; 
       trial[1] = y_trial0; 
 
       if (z_increase) {
		if(flag ==1){
			z_trial0 +=0.2f; 
			rotval = rotval - 1.57f;
			avatarRotation[id].setValue(x_trial0,2.0f,z_trial0,rotval);
                     }
            else if(flag == 3) {
			z_trial0 +=0.2f;
                  rotval = rotval + 1.57f;
                  avatarRotation[id].setValue(x_trial0,2.0f,z_trial0,rotval);
                     }
            else if(flag == 2) {
                  z_trial0 +=0.2f;
                  avatarRotation[id].setValue(x_trial0,2.0f,z_trial0,rotval);
                     }
            else {
			z_trial0 +=0.2f;
                  avatarRotation[id].setValue(x_trial0,2.0f,z_trial0,rotval);
                     }

                  flag = 2;
                    }

       else if  (z_decrease){
                 if(flag == 1) {
				rotval = rotval + 1.57f;
				z_trial0 -=0.2f;
				avatarRotation[id].setValue(x_trial0,2.0f,z_trial0,rotval);
                     }
                else if(flag == 3) {
				rotval = rotval - 1.57f;
				z_trial0 -=0.2f;
				avatarRotation[id].setValue(x_trial0,2.0f,z_trial0,rotval);
                     }

                 else if(flag == 2) {
				rotval = rotval +3.14f;
				z_trial0 -=0.2f;
			 	avatarRotation[id].setValue(x_trial0,2.0f,z_trial0,rotval);
                     }
                 else {
				z_trial0 -=0.2f;
			 	avatarRotation[id].setValue(x_trial0,2.0f,z_trial0,rotval);
                     }
			flag = 4;

			 trial[2] = z_trial0; 
 
      x_increase = false; 
      y_increase = false; 
      z_increase = false; 
      x_decrease = false; 
      y_decrease = false; 
      z_decrease = false; 
     } 
 
     if (id==1) { 
       if (x_increase) x_trial1 +=0.2f; 
       else if (x_decrease) x_trial1 -=0.2f; 
       trial[0] = x_trial1;  
 
       if (y_increase) y_trial1 +=0.2f; 
       else if (y_decrease) y_trial1 -=0.2f; 
       trial[1] = y_trial1; 
 
       if (z_increase) z_trial1 +=0.2f; 
       else if (z_decrease) z_trial1 -=0.2f; 
       trial[2] = z_trial1; 
  
       x_increase = false; 
       y_increase = false; 
       z_increase = false; 
       x_decrease = false; 
       y_decrease = false; 
       z_decrease = false; 
     } 
     if (id==2) { 
       if (x_increase) x_trial2 +=0.2f; 
       else if (x_decrease) x_trial2 -=0.2f; 
       trial[0] = x_trial2;  
 
       if(y_increase) y_trial2 +=0.2f; 
       else if (y_decrease) y_trial2 -=0.2f; 
       trial[1] = y_trial2; 
 
       if(z_increase) z_trial2 +=0.2f; 
       else if (z_decrease) z_trial2 -=0.2f; 
       trial[2] = z_trial2; 
 
       x_increase = false; 
       y_increase = false; 
       z_increase = false; 
       x_decrease = false; 
       y_decrease = false; 
       z_decrease = false; 
     } 
      
      
     System.out.println("trial[0] = " + trial[0] + "trial[1] = " +  
			trial[1] + "trial[2] = " + trial[2] ); 
     System.out.println("Avatar" + id +"on the move ...."); 
     avatarPosition[id].setValue(trial); 
     System.out.println("Value has been set "); 
   }  
    
   public void updateOrientation(int id, float x, float y, float z, float r){  
     System.out.println("inside updateorientation method..."); 
   } 
    
} 
 
/*This thread is responsible for the callbacks from the Server side */ 
 
class VRMLControlThread extends Thread { 
  private CVRUser thisClient; 
  private MultiCoordinator.Coordinator myCoordinator; 
  private com.visigenic.vbroker.IOP.IORHelper remote_ior_file;  
  private PartyScheduler.PartyCoordinator partyCoordinator; 
  VRMLControlThread(CVRUser client) 
  { thisClient = client; 
  } 
   
  public void run() 
  { try 
    { // Initialize the ORB. 
      org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(thisClient); 
       
      // Initialize the BOA. 
      org.omg.CORBA.BOA boa = orb.BOA_init(); 
       
       
      // Create the ClientControl object. 
      VRControlImpl control = 
	new VRControlImpl(thisClient); 
       
      // Export the newly created object. 
      boa.obj_is_ready(control);       
      System.out.println("Registering ......"); 
      // Register with Coordinator 
      System.out.println("Client Name =" + thisClient.clientName); 
      System.out.println("clientNumber=" + thisClient.clientNumber); 
      int id= thisClient.myCoordinator.register(thisClient.clientNumber.hashCode(), thisClient.clientName,(Client.ClientControl) control); 
      thisClient.clientID=id; 
      if (id < 20)  System.out.println("Registration Succeeded"); 
      else  System.out.println("Registration Failed"); 
       
      thisClient.id = thisClient.myCoordinator.numberOfMembers()-1; 
      System.out.println("YOUR TVR ID IS" + thisClient.id); 
 
      // Ready to service requests. 
      System.out.println("Control: Waiting for requests"); 
      //boa.impl_is_ready(); 
    } 
  catch(org.omg.CORBA.SystemException e) 
    { System.err.println(e); 
    } 
  } 
} 
 
