import java.awt.*;
import java.applet.Applet;
import java.util.*;
import java.io.*;

import vrml.external.Node;
import vrml.external.Browser;
import vrml.external.field.*;
import vrml.external.exception.*;

import netscape.javascript.*;



public class
CVRUser extends Applet implements  MuProtocol,Runnable,EventOutObserver {


    public MultiCoordinator.Coordinator myCoordinator;
    public PartyScheduler.PartyCoordinator partyCoordinator;

    /** The name of this Client. */
    public String clientName;
    public int clientID;

    /**The name of the Party*/
    public String partyName;
    public int partyID;

    /** Indicates if the client is successfully connected to the server. */
    boolean connected = false;


    private Thread running = null;
    private Thread controlThread;
    public  String clientNumber="1";

    private Node avatar = null;
    private Node TS2    = null;
    private Node PS2    = null;

    public final static int AVATARS = 3;
    private Browser b = null;
    EventInSFVec3f avatarPosition[] = new EventInSFVec3f[AVATARS];
    EventInSFRotation avatarRotation[] = new EventInSFRotation[AVATARS];
    float[] coord = new float[3];
    float[] rotation = new float[4];
    int id;

    private EventOutSFBool clicked1 = null;
    private EventOutSFVec3f currentPosition = null;


    public synchronized void
    init() {

        /* to get the handle of the CosmoPlayer browser,liveconnect is used*/

        JSObject win = JSObject.getWindow(this);
        JSObject doc = (JSObject)win.getMember("document");
        JSObject embeds = (JSObject)doc.getMember("embeds");

        b = (Browser)embeds.getSlot(0);

        System.out.println("Handle to VRML Browser got....");

        /* Here reference to the "translation" and "rotation" fields of the
           'AVATAR' nodes are got... */

        for(int i=0; i<AVATARS;i++){
            try {
                  avatar = b.getNode("AVATAR"+i);
                  System.out.println("handle to avatar node got here...");
                  avatarPosition[i] = (EventInSFVec3f)avatar.getEventIn("translation");
                  avatarRotation[i] = (EventInSFRotation)avatar.getEventIn("rotation");
            } catch (Exception e){
                b.setDescription("cannot get avatar");
                System.out.println("problem in getting avatar nodes...");
               }
        }

        try {
             /* here is where the handle to the VRML node is got from the
                applet side making use of the browser object's getNode method */

             TS2 = b.getNode("TS2");
             System.out.println("TouchSensor node handle got...");


             PS2 = b.getNode("PS2");
             System.out.println("PlaneSensor node handle got...");

            } catch (InvalidNodeException e){
                System.out.println("Invalid Node handle-problems....");
            }

            //Rerouting events from VRML to Java applet part...

            clicked1 = (EventOutSFBool) TS2.getEventOut("isActive");
            currentPosition = (EventOutSFVec3f) PS2.getEventOut("position_changed");

            /*The following advise method will in turn call the "callback"
               method which replaces the ProcessEvent method in JSAI
               method of interaction */
            clicked1.advise(this,null);
            currentPosition.advise(this,null);

         }  // end of init




	private int rrange(int low, int high)
	 {
	    return((int)(Math.random() * (high-low+1) + low));
	 }


    private boolean
    isConnected() {
      System.out.println("ChatUser: isConnected: " + connected);
      return(connected);
    }


    private boolean
    connect() {
      controlThread = new ClientControlThread(this);
      controlThread.start();
      return true;
    }

    private void binder() {
      // Initialize the ORB.
      System.out.println("Just entered binder method...");
      org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(this);
      System.out.println("ORB is initialized in binder() method...");
      // Calculate Start time
      long startTime = System.currentTimeMillis();
      // Bind to the Coordinator Object
      //myCoordinator = MultiCoordinator.CoordinatorHelper.bind(orb);
      partyCoordinator = PartyScheduler.PartyCoordinatorHelper.bind(orb);
      // Calculate stop time; print out statistics
      long stopTime = System.currentTimeMillis();
      System.out.println("Avg Ping to bind = "
			 + ((stopTime - startTime)/1000f) + " msecs");
      System.out.println("Party Scheduler is Ready");
    }

    /*  Convert the users message to bytes and send it over the channel. */

    public boolean
      broadcast(String message) {
      return myCoordinator.broadcast(message);
    }



    private void
    disconnect() {
      System.out.println("Deregistring Client ID" +clientID + clientName);
      myCoordinator.deregister(clientID);
      System.out.println("Deregistring complete ... Listing follows");
      int numberOfMembers= myCoordinator.numberOfMembers();
      String[] temp = new String[numberOfMembers];
      System.arraycopy(myCoordinator.getClientNames(),0, temp,0,numberOfMembers);
      for (int i=0;i< numberOfMembers; i++)
	System.out.println(temp[i]);
      System.out.println("Listing complete");
    }


    public void
    start() {
      System.out.println("CVRUser: start.");
      if (running == null) {
	running = new Thread(this);
	running.start();
      }
    }


    public void
    stop() {
      if (running != null) {
	running.stop();
	System.out.println("Thread stopped...");
	running = null;
      }
    }


    public void
      run() {
    }


    public void
      destroy() {
      System.out.println("destroyed session");
    }


    public void callback(EventOut who,double when,Object which)
     {
        if((who == clicked1) && !connected)
          {
            System.out.println("You have clicked the connection button...");

    	    partyName="sports";
    	    System.out.println("party name set to default value...");
    	    System.out.println("Just before call to binder method..");
	        binder();
	        System.out.println("Just after returning from binder method..");
	        System.out.println("Trying for creation of Party ....");

	        long startTime = System.currentTimeMillis();

	        if (partyCoordinator.createParty(partyName))
	          System.out.println("New Party created");
	        else
	          System.out.println("Party being joined");
	        long stopTime = System.currentTimeMillis();
	        System.out.println("Avg Ping to invoke = "
			     + ((stopTime - startTime)/1000f) + " msecs");

	        partyID= partyCoordinator.getPartyID(partyName);
	        System.out.println("Party Id is: "+partyID);

	        myCoordinator = partyCoordinator.getPartyHandle(partyID);
	        System.out.println("Received Party Handle");

	        clientNumber = "Balaji"+":"+(rrange(0,500) * rrange(0,500));
	        clientName   = "Shrideep"+":"+(rrange(0,1000) * rrange(0,1000));
	        connected = connect();
	        System.out.println("returning from connect call...");
	        return;
	      }
	     else if(who == currentPosition)
	      {
	        coord = ((EventOutSFVec3f)who).getValue();
	        System.out.println("Just after getting values from pos_Changed event...");
	        System.out.println("x:"+coord[0]+"y:"+coord[1]+"z:"+coord[2]);

	        if(connected)
	         {
	            try {
	                //send my id and my current position to server
	                broadcast(id+" "+MuProtocol.MOVE+" "+coord[0]+" "+
	                          coord[1]+" "+coord[2]);
	             } catch(Exception e) {
	                 System.out.println("Caught exception while invoking myPosition: "+e);
	            }
	         }
	      }
	 }


	 public void updatePosition(int id,float x,float y, float z)
	  {
	    float trial[] = new float[3];
	    trial[0] = x;
	    trial[1] = y;
	    trial[2] = z;
	    System.out.println("Avatar"+id+"on the move...");
	    avatarPosition[id].setValue(trial);
	  }


	 public void dataReceive(String Message)
	  {
	    StringTokenizer tok;
	    float x=0f,y=0f,z=0f,r=0f;

	    while (Message != null)
	     {
	        tok = new StringTokenizer(Message," ,\n\r\t");
	        Message = null;
	        int idOfMove = Integer.parseInt(tok.nextToken());
	        int command = Integer.parseInt(tok.nextToken());

	        x = Float.valueOf(tok.nextToken()).floatValue();
	        y = Float.valueOf(tok.nextToken()).floatValue();
	        z = Float.valueOf(tok.nextToken()).floatValue();

	        if(MuProtocol.MOVE == command)
	         {
	            updatePosition(idOfMove,x,y,z);
	         }
	     }
	  }


   }


/*This thread is responsible for the callbacks from the Server side */

class ClientControlThread extends Thread
{
  private CVRUser thisClient;
  private MultiCoordinator.Coordinator myCoordinator;
  private com.visigenic.vbroker.IOP.IORHelper remote_ior_file;
  private PartyScheduler.PartyCoordinator partyCoordinator;
  ClientControlThread(CVRUser client)
  { thisClient = client;
  }

  public void run()
  { try
    { // Initialize the ORB.
      org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(thisClient);

      // Initialize the BOA.
      org.omg.CORBA.BOA boa = orb.BOA_init();


      // Create the ClientControl object.
      ClientControlImpl control =
                 new ClientControlImpl(thisClient);

      // Export the newly created object.
      boa.obj_is_ready(control);


      System.out.println("Registering ......");
      // Register with Coordinator

      int id= thisClient.myCoordinator.register(thisClient.clientNumber.hashCode(), thisClient.clientName,(Client.ClientControl) control);
      thisClient.clientID=id;
      if (id < 20)

	{
          System.out.println("Registration Succeeded");
	}
      else
	{
	   System.out.println("Registration Failed");
	}

      // Ready to service requests.
      System.out.println("Control: Waiting for requests");
      //boa.impl_is_ready();
    }
    catch(org.omg.CORBA.SystemException e)
    { System.err.println(e);
    }
   }
}
