// CoordinatorImpl.java 
 
public class CoordinatorImpl 
      extends MultiCoordinator._sk_Coordinator 
{ 
  int numberOfMembers=0;
  int maxClients = 20; 
  public  Client.ClientControl[] thisClient = 
                      new Client.ClientControl[maxClients]; 
  String [] clientNames = new String[maxClients];

  CoordinatorImpl(String name) 
  { super(name); 
    System.out.println("Coordinator Object Created"); 
    for (int i=0; i < maxClients; i++) 
    { 
      thisClient[i] = null; 
    } 
  } 

  public boolean setMaxClients(int _maxClients) {
    if (maxClients < _maxClients) {
      Client.ClientControl[] tempClient= new Client.ClientControl[_maxClients];

      /*Lets copy the existing members into the enlarged array*/
      System.arraycopy(thisClient,0,tempClient,0,maxClients);

      /*Initialize the enlarged array which is not initialized*/
      for (int i=maxClients; i < _maxClients; i++)  { 
	tempClient[i]=null; 
      }  

      /*Copy back into our good ol array */
      System.arraycopy(tempClient,0,thisClient,0,_maxClients);
      maxClients = _maxClients;
      System.out.println("Number of Clients have been increased");
      return true;
    } else return false;
  }

  public int getMaxClients() {
    return maxClients;
  }

  public int numberOfMembers() {
    return numberOfMembers;
  }
  
  public String[] getClientNames() {
    String[] temp= new String[numberOfMembers];
    int j=0;
    for (int i=0; i <maxClients; i++) {
      if (thisClient[i] !=null) {
	temp[j]= clientNames[i];
	System.out.println("client"+ j + clientNames[i]);
	j++;
      }
    }
    return temp;
  }

  public boolean isEmpty() {
    if (numberOfMembers== 0) return true;
    else return false;
  }

  public int register(int clientHashCode, String ClientName,
                          Client.ClientControl clientObjRef) 
  { 
    System.out.println("Client " + clientHashCode + " Registering");
    return generateID(clientObjRef,ClientName);
  } 

  public  boolean deregister(int clientID) {
    thisClient[clientID]=null;
    numberOfMembers--;
    System.out.println("Number of members" + numberOfMembers);
    return true;
  }
 
  public boolean broadcast(String Message) {
    System.out.println("Start"); 

     // Calculate Start time
    long startTime = System.currentTimeMillis();
    for (int i=0; i < maxClients; i++) 
      { 
	if (thisClient[i] != null) 
	  thisClient[i].dataReceive(Message); 
      } 
    long stopTime = System.currentTimeMillis();
      System.out.println("Avg Ping to broadcast = "
			 + ((stopTime - startTime)/1000f) + " msecs");
    return true; 
    }

  public boolean whisper(String Message, int clientID) {
     return thisClient[clientID].dataReceive(Message); 
  }

  private synchronized int generateID(Client.ClientControl clientObjRef, String ClientName) {
    for (int i=0; i < maxClients; i++) { 
	if (thisClient[i] == null) {
	  thisClient[i]=clientObjRef;
	  clientNames[i] = ClientName;
	  numberOfMembers++;
	  System.out.println("Registering with ID: " + i +" heehaaaw"); 
	  return i;
	}
    }
    return maxClients++;
  }
    
} 
