//PartyCoordinatorImpl.java

public class PartyCoordinatorImpl
  extends PartyScheduler._sk_PartyCoordinator {
  int numberOfParties=0;
  int maxParties = 5 ; 
  public  MultiCoordinator.Coordinator[] thisCoord = 
                      new MultiCoordinator.Coordinator[maxParties]; 
  String [] partyNames = new String[maxParties];

  
  PartyCoordinatorImpl(String name) {
    super(name); 
    System.out.println("PartyCoordinator Object Created"); 
    for (int i=0; i < maxParties; i++) 
    { 
      thisCoord[i] = null; 
      partyNames[i]= null;
    } 
  } 


  public boolean createParty(String PartyName) {
    System.out.println("Initiation of creation.....");
    for (int i=0; i<maxParties; i++) {
      if(partyNames[i]!=null) {
	if (partyNames[i].equals(PartyName)) 
	  return false;
      }
    }
    
    int temp=generateID(PartyName);
    return true;
  }			  

  private synchronized int generateID(String PartyName) {
    for (int i=0; i < maxParties; i++) {
      System.out.println("Wait ... generating ID");
      if (thisCoord[i] == null) {
	  try { // Initialize the ORB.
	    org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init();
	    
	    // Initialize the BOA.
	    org.omg.CORBA.BOA boa = orb.BOA_init();
	    
	    // Create the Coordinator object.
	    thisCoord[i] = new CoordinatorImpl(PartyName);
	    partyNames[i] = PartyName;
	    // Export the newly created object.
	    boa.obj_is_ready(thisCoord[i]);
	    
	    // Ready to service requests.
	    System.out.println("Coordinator waiting for requests");
	    System.out.println("Returning ID"); 
	    return i;
	  }
	  catch(org.omg.CORBA.SystemException e) {
	    System.err.println(e);
	  }
	  return i;
      }
    }
    return maxParties++;
  }  
  
  public MultiCoordinator.Coordinator getPartyHandle(int partyID) {
    return thisCoord[partyID];
  }
    
  public int getPartyID(String PartyName) {
    for (int i=0; i<maxParties; i++) {
      if (partyNames[i]!=null && partyNames[i].equals(PartyName)) 
	return i;
    }
    return maxParties++;
  }
}

