package MultiCoordinator;
/**
<p>
<ul>
<li> <b>Java Class</b> MultiCoordinator._tie_Coordinator
<li> <b>Source File</b> MultiCoordinator/_tie_Coordinator.java
<li> <b>IDL Absolute Name</b> ::MultiCoordinator::Coordinator
<li> <b>Repository Identifier</b> IDL:MultiCoordinator/Coordinator:1.0
</ul>
<b>IDL definition:</b>
<pre>
    interface Coordinator {
      boolean setMaxClients(
        in long arg0
      );
      long getMaxClients();
      long numberOfMembers();
      typedef sequence&ltstring&gt sequence_of_string;
      ::MultiCoordinator::Coordinator::sequence_of_string getClientNames();
      boolean isEmpty();
      long register(
        in long arg0,
        in string arg1,
        in ::Client::ClientControl arg2
      );
      boolean deregister(
        in long arg0
      );
      boolean broadcast(
        in string arg0
      );
      boolean whisper(
        in string arg0,
        in long arg1
      );
    };
</pre>
</p>
*/
public class _tie_Coordinator extends MultiCoordinator._sk_Coordinator {
  private MultiCoordinator.CoordinatorOperations _delegate;
  public _tie_Coordinator(MultiCoordinator.CoordinatorOperations delegate, java.lang.String name) {
    super(name);
    this._delegate = delegate;
  }
  public _tie_Coordinator(MultiCoordinator.CoordinatorOperations delegate) {
    this._delegate = delegate;
  }
  public MultiCoordinator.CoordinatorOperations _delegate() {
    return this._delegate;
  }
  /**
  <p>
  Operation: <b>::MultiCoordinator::Coordinator::setMaxClients</b>.
  <pre>
    boolean setMaxClients(
      in long arg0
    );
  </pre>
  </p>
  */
  public boolean setMaxClients(
    int arg0
  ) {
    return this._delegate.setMaxClients(
      arg0
    );
  }
  /**
  <p>
  Operation: <b>::MultiCoordinator::Coordinator::getMaxClients</b>.
  <pre>
    long getMaxClients();
  </pre>
  </p>
  */
  public int getMaxClients() {
    return this._delegate.getMaxClients(
    );
  }
  /**
  <p>
  Operation: <b>::MultiCoordinator::Coordinator::numberOfMembers</b>.
  <pre>
    long numberOfMembers();
  </pre>
  </p>
  */
  public int numberOfMembers() {
    return this._delegate.numberOfMembers(
    );
  }
  /**
  <p>
  Operation: <b>::MultiCoordinator::Coordinator::getClientNames</b>.
  <pre>
    ::MultiCoordinator::Coordinator::sequence_of_string getClientNames();
  </pre>
  </p>
  */
  public java.lang.String[] getClientNames() {
    return this._delegate.getClientNames(
    );
  }
  /**
  <p>
  Operation: <b>::MultiCoordinator::Coordinator::isEmpty</b>.
  <pre>
    boolean isEmpty();
  </pre>
  </p>
  */
  public boolean isEmpty() {
    return this._delegate.isEmpty(
    );
  }
  /**
  <p>
  Operation: <b>::MultiCoordinator::Coordinator::register</b>.
  <pre>
    long register(
      in long arg0,
      in string arg1,
      in ::Client::ClientControl arg2
    );
  </pre>
  </p>
  */
  public int register(
    int arg0,
    java.lang.String arg1,
    Client.ClientControl arg2
  ) {
    return this._delegate.register(
      arg0,
      arg1,
      arg2
    );
  }
  /**
  <p>
  Operation: <b>::MultiCoordinator::Coordinator::deregister</b>.
  <pre>
    boolean deregister(
      in long arg0
    );
  </pre>
  </p>
  */
  public boolean deregister(
    int arg0
  ) {
    return this._delegate.deregister(
      arg0
    );
  }
  /**
  <p>
  Operation: <b>::MultiCoordinator::Coordinator::broadcast</b>.
  <pre>
    boolean broadcast(
      in string arg0
    );
  </pre>
  </p>
  */
  public boolean broadcast(
    java.lang.String arg0
  ) {
    return this._delegate.broadcast(
      arg0
    );
  }
  /**
  <p>
  Operation: <b>::MultiCoordinator::Coordinator::whisper</b>.
  <pre>
    boolean whisper(
      in string arg0,
      in long arg1
    );
  </pre>
  </p>
  */
  public boolean whisper(
    java.lang.String arg0,
    int arg1
  ) {
    return this._delegate.whisper(
      arg0,
      arg1
    );
  }
}
